local bri1 = love.graphics.newImage("bri1.png")
local h = love.window.getHeight()
local w = love.window.getWidth()

local pla = {
grid_x = 3*32+16,
grid_y = 3*32+16,
act_x = 3*32+16,
act_y = 3*32+16,
speed = 2,
r=0,
ismoving = {x=false,y=false,overal=false,overalstate=true},
g_r = 0,
dir = "r",
ll=false,
rr=false,
uu=false
}
local dirinfo = {
[270] = {d="u",l=180,r=360,is={true,false,false,false}},
[0] = {d="r",l=270,r=90,is={false,false,false,true}},
[360] = {d="r",l=270,r=90,is={false,false,false,true}},
[180] = {d="l",l=90,r=270,is={false,false,true,false}},
[90] = {d="d",l=0,r=180,is={false,true,false,false}},
}

function setisplayermowing(elem,state,dir)
    if elem.ismoving then
	elem.ismoving[dir] = state
	elem.ismoving.overal = (elem.ismoving.x  or elem.ismoving.y)
   end
end

function rotateElement(p,dt)
	if p.dir == "l" then
		p.r=p.r-dt*3*32
		if p.r < 0 then
			p.g_r = 360
		end
		if p.r <= p.g_r then
			p.r = p.g_r
		end
		
	else
		p.r=p.r+dt*3*32
		
		
		if p.r > 360 then
			p.g_r = 0
		end
		if p.r >= p.g_r then
			p.r = p.g_r
		end
	end
end

function moveElement(elem,dt,dir) --smoudh moving
   if not dir then
	moveElement(elem,dt,"x")
	moveElement(elem,dt,"y")
   else
  	 if elem["act_"..dir] - elem["grid_"..dir] < 2*(32*elem.speed*dt) and elem["grid_"..dir] - elem["act_"..dir] < 2*(32*elem.speed*dt) then
 	     elem["act_"..dir] = elem["grid_"..dir]
	     setisplayermowing(elem,false,dir)
 	  elseif not (elem["act_"..dir] - elem["grid_"..dir] < 2*(32*elem.speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] - 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  elseif not (elem["grid_"..dir] - elem["act_"..dir] < 2*(32*elem.speed*dt)) then
 	     elem["act_"..dir] = elem["act_"..dir] + 32*elem.speed*dt
	     setisplayermowing(elem,true,dir)
 	  end
   end
end

function moveGrid(elem,dir1,dir2,dir3,dir4) -- actual position change
	if elem.act_y == elem.grid_y and elem.act_x == elem.grid_x  then
        	elem["grid_"..dir1] = elem["grid_"..dir1] + dir2
		elem.direction = elem.grid_dir
	end
end

local center = w/2
local camdist = center/math.tan(math.rad(30))

local myShader = love.graphics.newShader[[
	extern number camdist;
	extern number h;
	extern number w;
	extern Image tile;
	extern number tw;
	extern number th;
	extern number plax;
	extern number play;
	extern number plar;
	vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords ){
		vec4 pixel = Texel(texture, texture_coords );
		number pr = (plar+180) + (screen_coords.x - w/2)*(60/w);
		number pr2 = (screen_coords.x - w/2)*(60/w);
		if (pr>=360) {
			pr = pr - 360;
		}
		if (pr<=0) {
			pr = 360+pr;
		}
		if (pr2>=360) {
			pr = pr - 360;
		}
		if (pr2<=0) {
			pr = 360+pr;
		}
		number y = play+(32*5)*cos(plar*3.14159265/180);
		number x = plax+(32*5)*sin(plar*3.14159265/180);
		number d = h/2;
		number sc = camdist*32/(d-(h-screen_coords.y))+d/2;
		number sc2 = sc/cos(pr2*3.14159265/180);
		number olddist = 32*5/cos(pr2*3.14159265/180);
		number newx = x-(olddist-sc2)*cos(pr*3.14159265/180);
		number newy = y-(olddist-sc2)*sin(pr*3.14159265/180);
		number d2 = floor((floor(newy/32)+1-newy/32)*32);
		number d3 = floor((floor(newx/32)+1-newx/32)*32);
		vec4 pixel2 = Texel(tile,vec2(d2/tw,d3/th));
		pixel.r = pixel2.r;
		pixel.g = pixel2.g;
		pixel.b = pixel2.b;
		return pixel;	
	}
]]

myShader:send("camdist",camdist)
myShader:send("h",h)
myShader:send("w",w)
myShader:send("tile",bri1)
myShader:send("tw",32)
myShader:send("th",32)

function love.update(dt)
	if pla.act_y ~= pla.grid_y or pla.act_x ~= pla.grid_x  then
		moveElement(pla,dt)
	end
	if pla.r ~= pla.g_r then
		rotateElement(pla,dt)
	end
	if pla.r == pla.g_r and (not pla.ismoving.overal) then
    		if pla.uu and dirinfo[pla.g_r].is[1] then moveGrid(pla,"y",-32,0,1) end
    		if pla.uu and dirinfo[pla.g_r].is[2] then moveGrid(pla,"y",32,0,-1) end
    		if pla.uu and dirinfo[pla.g_r].is[3] then moveGrid(pla,"x",-32,1,0) end
    		if pla.uu and dirinfo[pla.g_r].is[4] then moveGrid(pla,"x",32,-1,0) end
		if pla.ll then
			pla.g_r = dirinfo[pla.g_r].l
			pla.dir = "l"
		end
		if pla.rr then
			pla.g_r = dirinfo[pla.g_r].r
			pla.dir = "r"
		end
	end
	myShader:send("plax",pla.act_x)
	myShader:send("play",pla.act_y)
	myShader:send("plar",pla.r)
end

function love.draw()
	love.graphics.setShader(myShader)
	love.graphics.rectangle("fill",0,h/2,w,h/2)
	love.graphics.setShader()
end

function love.keypressed(key)
	if key == "left" then
    		pla.ll = true
		
	elseif key == "right" then
    		pla.rr = true
	elseif key == "up" then
    		pla.uu = true
		
	end
end

function love.keyreleased(key)
	if key == "left" then
    		pla.ll = false
	elseif key == "right" then
    		pla.rr = false
	elseif key == "up" then
    		pla.uu = false	
	end
end